/*****************************************************/
/**                                                 **/
/**    3DAnim crit par J.M.MICHEL et  S.PISSAVY    **/
/**  ---------------------------------------------  **/
/**  M.I.A.1  (1993)                 ESIG Limoges   **/
/**                                                 **/
/**        V1.00 termine ce jeudi 6 mai 1993       **/
/*****************************************************/


/******************************/
/* DECLARATION DES LIBRAIRIES */
/******************************/
#include <io.h>
#include <dos.h>
#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <graphics.h>


/*****************************/
/* DECLARATION DES FONCTIONS */
/*****************************/
void usage(void);        /* Notice d'utilisation et Copyright    */
void examine_arg(char *argv);/* Examine les paramtres ligne commande*/
void init_table(void);   /* Initialisation de tab_sin & tab_cos  */
void init_gfx(void);     /* Ouvrerture de deux crans graphiques */
void charge(char *chaine);       /* Chargement du fichier en mmoire     */
void fin_gfx(void);      /* Fermeture de ces crans              */
void calcule(void);      /* Calcul des variables temporaires     */
void sp_to_pl(void);     /* Calcul des coordonnes 2D            */
void tri(void);          /* Tri des faces suivant l'loignement  */
void affiche(void);      /* Affichant de l'objet                 */
void keyboard(void);     /* Gestion des dplacements au clavier  */
void demo(void);         /* Rotation automatique de l'objet      */


/**************************************/
/* DECLARATION DES VARIABLES GLOBALES */
/**************************************/

float tab_sin[360];           /* Table de prcalcul des sinus      */
float tab_cos[360];           /* Table de prcalcul des cosinus    */

int xangle,yangle,zangle;     /* Angles de rotation en x, y et z   */
int xdep, ydep, zdep;         /* Translations suivant x, y et z    */

float Ta,Tb,Tc,Td;            /* Variables temporaires             */
float Te,Tf,Tg,Th,Ti;         /* pour les calculs                  */

int nbfaces;                  /* Nombre de faces total de l'objet  */
int nbpoints;                 /* Nombre de points total de l'objet */

int faces[100][22];    /* Couleur des faces, Nombre de sommets par  */
					  /* faces, ndice des sommets                  */

int faces_triees[100][2];  /* Faces tries dans l'ordre de */
                          /*    leur loignement moyen    */

int *x3d;      /* tableaux des coordonnes 3d (spatiales) */
int *y3d;      /* de l'objet redimmensionnes par la      */
int *z3d;      /* fonction charge()                       */

int *x2d;      /* tableaux des coordonnes 2d (planaires) */
int *y2d;      /* redimensionns par la fonction charge() */

int *new_z;    /* Nouvelles coordonnes spatiales z aprs transformation */

int rouge[14];  /*** Couleurs dcompposes en R,V et B ***/
int vert[14];
int bleu[14];

int sortie = 0;    /*** Dtermine si l'on sort du programme ou non   ***/

/*** Variables pouvant tre affectes par des paramtres du DOS ********/
int DRAPEAU;       /*** Dit si l'on est en 3dpleine(0) ou filaire(1) ***/
float PT_FUITE;    /*** point de fuite de la perspective             ***/
int ANGLE;         /*** pas de l'angle de rotation en x,y et z       ***/



/**********************************************************
 **  Fonction principale de notre programme (boucle qui  **
 **    incrmente les angles et appelle les fonctions)   **
 **********************************************************/
void main(int argc, char **argv)
{
	int i;

	if (argc == 1)
		usage();
	else
	{
		charge(argv[1]);
		PT_FUITE = 300.01;
		ANGLE = 8;
		DRAPEAU = 0;
		for (i = 1 ; i < argc ; i++)
			examine_arg(argv[i+1]);
	}

	init_table();
	init_gfx();

	xdep = ydep = zdep = xangle = yangle = zangle = 0;

	do
	{
		demo();
		if (sortie != 1)
			keyboard();
	}while(sortie == 0);
	fin_gfx();
}




/**********************************************************
 **  Fonction indiquant le mode d'emploi  l'utilisateur **
 **     qui en a fait la demande ou qui a mal lanc le   **
 **      logiciel (c'est  dire sans aucun paramtres    **
 **********************************************************/
void usage(void)
{
	printf("\n     --- 3DANIM V1.00 --- Mai 1993\n");
	printf("(C) Jean Marc MICHEL et Sbastien PISSAVY\n\n");
	printf("Logiciel d'animation en trois dimensions en temps rl.\n");
	printf("3DAnim est coupl  3DMOD afin de modliser les objets 3D.\n");
	printf("\n");
	printf("Syntaxe :  3DANIM <Fichier.3da> [Options]\n\n");
	printf("Les options doivent toujours tre places aprs le nom du fichier d'entre.\n");
	printf("Elles sont au nombre de trois (toutes optionnelles) :");
	printf("\n\n /Fcoord   Dtermine la coordonne Z du point de fuite (coord de 150  500)");
	printf("\n /Aangle   Dtermine le pas de l'animation (angle de 1  20)");
	printf("\n /VF       Initialise la vue en 3d filaire classique");
	printf("\n /VC       Initialise la vue en 3d filaire avec faces caches");
	printf("\n /VP       Initialise la vue en 3d faces pleines\n\n");
	exit(0);
}



/**********************************************************
 **     Fonction qui examine les paramtres passs en    **
 **   arguments de la ligne de commande, et qui agit en  **
 **                    consquence                       **
 **********************************************************/
void examine_arg(char *chaine)
{
	char chainedecarac[10];
	int i, nombre;

	if (chaine[0] == '?')
		usage();
	else
	{
		if ((chaine[0] == '/') || (chaine[0] == '-'))
		{
			switch(chaine[1])
			{
				case 'A' :
				case 'a' :  for ( i = 2 ; i < strlen(chaine) ; i++)
								chainedecarac[i-2] = chaine[i];
							chainedecarac[i-2] = '\0';
							nombre = atoi(chainedecarac);
							if ((nombre > 0) && (nombre < 101)) ANGLE = nombre;
							break;

				case 'f' :
				case 'F' :  for ( i = 2 ; i < strlen(chaine) ; i++)
								chainedecarac[i-2] = chaine[i];
							chainedecarac[i-2] = '\0';
							nombre = atoi(chainedecarac) + 0.01;
							if ((nombre > 149) && (nombre < 501)) PT_FUITE = nombre;
							break;

				case 'v' :
				case 'V' :  switch(chaine[2])
							{
								case 'F' :
								case 'f' : DRAPEAU = 2; break;
								case 'C' :
								case 'c' : DRAPEAU = 1; break;
								case 'P' :
								case 'p' : DRAPEAU = 0; break;
							}
							break;
				case '?' : usage();
				case ' ' : usage();
			}
		}
	}
}




/**********************************************************
 **   Fonction initialisant les tableaux tab_sin[] et    **
 **   tab_cos[] avec des valeurs de sinus et cosinus     **
 **     prcalcules, pour augmenter la rapidit         **
 **********************************************************/
void init_table(void)
{
     int i;                /* indice des tableaux  initialiser pour 360 */
     double r;             /* valeur en radian dont on cherche sin et cos */

     for ( i = 0 ; i < 360 ; i++ ) /* boucle pour les 360 possibles      */
     {
          r = i * 3.14159 / 180.0;  /* conversion des degrs en radians    */
          tab_sin[i] = sin(r);      /* remplissage de la table des sinus   */
          tab_cos[i] = cos(r);      /* remplissage de la table des cosinus */
     }
}




/**********************************************************
 **    Fonction chargeant les donnes constitutives de   **
 ** l'objet dans les tableaux (coordonnes, faces, etc.) **
 **********************************************************/
void charge(char *chaine)
{
	FILE *fichier;
	int i,j;
	char *str;

	/* ouverture du fichier objet */
	if ((fichier = fopen(chaine, "rb")) == NULL)
	{
		printf("Fichier %s introuvable.\n",chaine);
		exit(1);
	}


	/******** Lecture des couleurs sous forme RVB ******/
	for (i = 0 ; i < 14 ; i++)
	{
		fread(&rouge[i],sizeof(int),1,fichier);
		fread(&vert[i],sizeof(int),1,fichier);
		fread(&bleu[i],sizeof(int),1,fichier);
	}

	/* lecture et initialisation du nombre de faces de l'objet */
	fread(&nbfaces,sizeof(int),1,fichier);

	/* lecture et initialisation du nombre de points de l'objet */
	fread(&nbpoints,sizeof(int),1,fichier);

	/*********************************************************************
	 *** Ici on rajuste nos tableaux suivants les nbfaces et nbpoints ***
	 *********************************************************************/

	/**** Test si mmoire suffisante ****/
	if ((str=malloc(7 * nbpoints * sizeof(int))) == NULL)
	{
		printf("Mmoire insuffisante pour l'allocation.\n");
		exit(1);  /* fin du programme si mmoire insuffisante */
	}
	free(str);

	/***** Ok, on peut y aller gaiement *****/
	x3d = (int *)malloc(nbpoints * sizeof(int));
	y3d = (int *)malloc(nbpoints * sizeof(int));
	z3d = (int *)malloc(nbpoints * sizeof(int));
	new_z = (int *)malloc(nbpoints * sizeof(int));
	x2d = (int *)malloc(nbpoints * sizeof(int));
	y2d = (int *)malloc(nbpoints * sizeof(int));
	new_z = (int *)malloc(nbpoints * sizeof(int));

	/*********************************************************
	 *** On charge les valeurs dans les tableaux rajusts ***
	 *********************************************************/

	for (i = 0 ; i < nbpoints ; i++)
	{
		 fread(&x3d[i],sizeof(int),1,fichier);  /*** lecture des ..      */
		 fread(&y3d[i],sizeof(int),1,fichier);  /* coordonnes X, Y.. et */
		 fread(&z3d[i],sizeof(int),1,fichier);  /* Z pour chaque point.  */
	}

	for (i = 0 ; i < nbfaces ; i++)
	{
		 fread(&faces[i][0],sizeof(int),1,fichier);    /*** couleur ***/
		 fread(&faces[i][1],sizeof(int),1,fichier);    /*** nb sommets ***/

		 for (j = 0 ; j < faces[i][1] ; j++)
		 {                          /*indices des sommets des faces ***/
			  fread(&faces[i][2+j],sizeof(int),1,fichier);
		 }
	}

	for (i = 0 ; i < nbfaces ; i++) /* on remplit faces_triees */
		faces_triees[i][0] = i;

	/* fermeture du fichier de donnes */
	fclose(fichier);
}






/**********************************************************
 **  Fonction dfinissant les crans graphiques 640*350  **
 **      et initialisant la palette de 16 couleurs       **
 **********************************************************/
void init_gfx(void)
{
	 int i, errorcode;
	 struct palettetype pal;

     /* selectionne un pilote et un mode supportant les pages multiples */
     int gdriver = VGA, gmode = VGAMED;

     /* initialisation des variables graphiques et locales */
     initgraph(&gdriver, &gmode, "");

     /* lecture du rsultat de l'initialisation */
     errorcode = graphresult();
     if (errorcode != grOk)  /* une erreur  eu lieu */
     {
          printf("Erreur graphique : %s\n",grapherrormsg(errorcode));
		  exit(4); /* termine avec un code d'erreur */
	 }
	 setvisualpage(0);
	 setactivepage(0);

	 getpalette(&pal);

     /* choix de la palette de couleur */
	 for(i = 1 ; i < 15 ; i++)
		setrgbpalette(pal.colors[i],rouge[i-1],vert[i-1],bleu[i-1]);

	 setviewport(0,0,639,349,1);
}



/**********************************************************
 **    Fonction fermant les deux crans graphiques et    **
 **        revenant ainsi au mode texte initial          **
 **********************************************************/
void fin_gfx(void)
{
     closegraph();
}



/*************************************************
 **  Fonction boucle qui incrmente les angles  **
 **           et appelle les fonctions          **
 *************************************************/
void demo(void)
{
	do{
		calcule();
		sp_to_pl();
		if (DRAPEAU != 2) tri();
		affiche();

		xangle += ANGLE + 1 ; if (xangle > 359) xangle = 0;
		yangle -= ANGLE + 2 ; if (yangle < 0) yangle = 359;
		zangle -= ANGLE + 3 ; if (zangle < 0) zangle = 359;
	}while(!kbhit());
	if (getch() == 27)
		sortie = 1;
}



/*************************************************************/
/* GESTION DU CLAVIER POUR LES ROTATIONS ET LES TRANSLATIONS */
/*************************************************************/
void keyboard(void)
{
	char carac;

	do
	{
		calcule();  /* pr-calcul en fonction des angles et dplacements */
		sp_to_pl(); /* conversion des coordonnes des points 3D en 2D    */
		if (DRAPEAU != 2) tri();      /* tri des faces en fonction de l'loignement moyen  */
		affiche();  /* affichage de l'objet sur l'cran   */

		/* test si une touche a t enfonce et laquelle */
		switch (carac=getch())
		{
			/* dplacements suivant l'axe x */
			case '2' : xdep -= 5 ; if (xdep < -100) xdep = -100; break;
			case '3' : xdep += 5 ; if (xdep > 100) xdep = 100; break;

			/* dplacements suivant l'axe y */
			case '7' : ydep -= 5 ; if (ydep < -50) ydep = -50; break;
			case '4' : ydep += 5 ; if (ydep > 50) ydep = 50; break;

			/* dplacements suivant l'axe z */
			case '5' : zdep -= 20 ; if (zdep < -700) zdep = -700; break;
			case '9' : zdep += 20 ; if (zdep > 50) zdep = 50; break;

			/* rotations autour de l'axe x */
			case 'a' : xangle +=ANGLE ; if (xangle > 359) xangle = 0; break;
			case 'q' : xangle -=ANGLE ; if (xangle < 0) xangle = 359; break;

			/* rotations autour de l'axe y */
			case 'z' : yangle +=ANGLE ; if (yangle > 359) yangle = 0; break;
			case 's' : yangle -=ANGLE ; if (yangle < 0) yangle = 359; break;

			/* rotations autour de l'axe z */
			case 'e' : zangle +=ANGLE ; if (zangle > 359) zangle = 0; break;
			case 'd' : zangle -=ANGLE ; if (zangle < 0) zangle = 359; break;

			case  27 : sortie = 1; break;
			case '+' :  DRAPEAU++; if (DRAPEAU > 2) DRAPEAU = 0; break;

			case '0' : zdep = ydep = xdep = xangle = yangle = zangle = 0; break;
		}
  }while ((carac != ' ') && (sortie ==0));
}




/**********************************************************
 **  Fonction calculant des valeurs intermdiaires pour  **
 **     chaque angle en fonction de sinus et cosinus     **
 **********************************************************/
void calcule(void)
{
    Ta = tab_cos[zangle] * tab_cos[yangle];
    Tb = tab_sin[zangle] * tab_cos[yangle];
    Tc = -tab_sin[yangle];
    Td = -tab_sin[zangle] * tab_cos[xangle] + tab_cos[zangle] * tab_sin[yangle] * tab_sin[xangle];
    Te = tab_cos[zangle] * tab_cos[xangle] + tab_sin[zangle] * tab_sin[yangle] * tab_sin[xangle];
    Tf = tab_cos[yangle] * tab_sin[xangle];
    Tg = tab_sin[zangle] * tab_sin[xangle] + tab_cos[zangle] * tab_sin[yangle] * tab_cos[xangle];
    Th = -tab_cos[zangle] * tab_sin[xangle] + tab_sin[zangle] * tab_sin[yangle] * tab_cos[xangle];
    Ti = tab_cos[yangle] * tab_cos[xangle];
}



/**********************************************************
 **  Fonction calculant les coordonnes planaires avec   **
 **  les coordonnes spatiales pour tous les points, de  **
 **       mme que new_z la composante z courante        **
 **********************************************************/
void sp_to_pl(void)
{
    int i;
    float Q;
    int x,y,z;

	/* transformation des points 3D en points 2D */
	for ( i = 0 ; i < nbpoints ; i++)
	{
		  x=x3d[i]; /* coordonne x 3D du point */
		  y=y3d[i]; /* coordonne y 3D du point */
		  z=z3d[i]; /* coordonne z 3D du point */

         /* calcul de Q en fonction du point de fuite */
         Q = 1 - ((Tc * x) + (Tf * y) + (Ti * z) + zdep ) / PT_FUITE;

         /* calcul des coordonnes x 2D des points */
		 x2d[i] = 320 + ((Ta * x) + (Td * y) + (Tg * z) + xdep ) / Q*0.8;

         /* calcul des coordonnes y 2D des points */
		 y2d[i] = 175 + (((Tb * x) + (Te * y) + (Th * z) + ydep ) / Q*0.7);

         /* calcul des coordonnes z 3D aprs transformation pour le calcul */
         /* de la profondeur moyenne de la face par la fonction tri()       */
         new_z[i] = (Ti * z) + (Tf * y) +(Tc * x) + zdep;
	 }
}



/**********************************************************
 **   Fonction d'affichage des faces dans l'ordre dans   **
 ** lequel elles ont t tries, et suivant leur couleur **
 **********************************************************/
void affiche(void)
{
     static int quellepage;  /* numro de la page active affiche */
     int i,j,k,piv;
     int nbsommet;    /* nombre de sommets sur la face courante   */
	 int poly[40];    /* nombre de sommets maximum par faces = 20 */

     /* on slectionne la page cran sur laquelle on dessine */
     setactivepage(quellepage);

     /* effacement de cette page cran */
     cleardevice();

     i = nbfaces - 1;
     do{
          piv = faces_triees[i][0];

          nbsommet = faces[piv][1];

		  k = 1;
          for(j = 0 ; j < nbsommet * 2 ; j += 2)
          {
               k++;
               poly[j]  = x2d[faces[piv][k]];
               poly[j+1] = y2d[faces[piv][k]];
          }

		  /* Choix si filaire ou 3dpleine et action de remplir ou tracer */
		  switch(DRAPEAU)
		  {                                              /**** 3d pleine ***/
			case 0 : setcolor(faces[piv][0]);
					 setfillstyle(SOLID_FILL,faces[piv][0]);
					 fillpoly(nbsommet,poly); break;

									 /**** 3d filaire avec faces caches ***/
			case 1 : setcolor(15);
					 setfillstyle(SOLID_FILL,0);
					 fillpoly(nbsommet,poly); break;

											   /*** 3d filaire classique ***/
			case 2 : setcolor(15);
					 for (k = 0 ; k < faces[i][1]-1 ; k++)
						line(x2d[faces[i][k+2]],y2d[faces[i][k+2]],x2d[faces[i][k+3]],y2d[faces[i][k+3]]);
					 line(x2d[faces[i][k+2]],y2d[faces[i][k+2]],x2d[faces[i][2]],y2d[faces[i][2]]);
					 break;

		  }
	 }while (--i > -1);

     setvisualpage(quellepage);
     quellepage = (quellepage ^ 1);   /*** quellepage = 0 ou 1 ***/
}



/**********************************************************
 **  Fonction permettant de trier les faces suivant leur **
 **  loignement moyen et de les ranger dans un tableau  **
 **********************************************************/
void tri(void)
{
     int  g, i;
     int  som;      /* somme loignement multipli pour + de prcision */
     int  piv;      /* variable temporaire pour 'arer' le code        */
     int  triage;   /* dtermine si le tri est fini ou non             */
     int  swap;     /* contient variable temporaire pour le swap       */
     int  nbsommet; /* nombre de sommets de chaques faces              */

     /* Remplissage du tableau faces_triees */
     for(g = 0 ; g < nbfaces ; g++)
     {
          piv = faces_triees[g][0];
          nbsommet = faces[piv][1]; /* lit le nombre de sommet    */
          som = 0;                  /* initialisation de la somme */

          for(i = 0 ; i < nbsommet ; i++)
          {
               som = som + new_z[faces[piv][2+i]];  /* somme z de chaque sommet */
          }

          /* sauvegarde dans le tableau de la profondeur moyenne de la face */
          faces_triees[g][1] = (som * 10)/nbsommet;
     }

     /* Routine de tri  bulle proprement dite */
     do{
          triage = 0;
          for ( i = 0 ; i < nbfaces-1 ; i++)
          {
               if (faces_triees[i][1]<faces_triees[i+1][1])
               {
                    triage = 1;

                    /* on permute les deux valeurs du tableau */
                    swap = faces_triees[i][1];
                    faces_triees[i][1] = faces_triees[i+1][1];
                    faces_triees[i+1][1] = swap;

                    swap = faces_triees[i][0];
                    faces_triees[i][0] = faces_triees[i+1][0];
                    faces_triees[i+1][0] = swap;
               }
          }
     }while (triage == 1);
}



