/****************************************************************************
 **                                                                        **
 ** MODELEUR 3D crit par S. PISSAVY                        ESIG Limoges   **
 ** --------------------------------                        ------------   **
 **                                     M.I.A.1                            **
 **                                     -------                            **
 **                     V1.00 termine ce jeudi 6 mai 1993                 **
 **                                                                        **
 ****************************************************************************/


/******************
   ***            ***
	***  INCLUDES  ***
	  ***            ***
		******************/

#include <stdio.h>
#include <graphics.h>
#include <conio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <dos.h>


/********************
   *** DECLARATIONS ***
	 ***     DES      ***
	   ***  FONCTIONS   ***
		 *******************/

void page_presentation(void); /*** Affiche noms auteurs et version du soft ***/

void init_gfx(void);    /*** Initialisation de l'cran graphique  ***/
void init_couleur(void);/*** Initialisation de palette couleurs   ***/
void fin_gfx(void);     /*** Fermeture de l'cran graphique       ***/

int gestion_erreur(int errval,int ax,int bp,int si); /*** Gre erreurs DOS ***/

int mini(int, int);       /*** Renvoie le plus petit de 2 nombres  ***/

void saisie(void);     /*** Fonction de la fentre de saisie      ***/
void visu(void);       /*** Fonction de la fentre de visualisal. ***/
void couleur(void);    /*** Fonction de la fentre des couleurs   ***/

void affiche_couleur(void); /*** Affiche la palette des couleurs  ***/

void affiche_etat_face(int);  /*** Infos sur point d'aprs son indice ***/
void affiche_etat_point(int); /*** Infos sur face d'aprs son indice  ***/


void fenetre(int);     /*** Dessine une fentre (int = 1, 2 ou 3) ***/
void ligne1(void);     /*** Dessine la ligne d'tat des messages  ***/
void ligne2(void);     /*** Dessine la ligne d'tat des erreurs   ***/
void active(int);      /*** Dessine cadre autour fentre active   ***/
void refresh(int,int); /*** Rafraichissement de tout l'cran      ***/
void affiche_3d(void); /*** Rafraichissement fentre visusalisal. ***/

void affiche_menu(void);    /*** Affiche le menu principal ***/
void affiche_fichier(void); /*** Affiche sous-menu FICHIER ***/
void affiche_saisie(void);  /*** Affiche sous-menu SAISIE  ***/
void affiche_effacer(void); /*** Affiche sous-menu EFFACER ***/

		 /*** Saisie d'un nombre  n caractres compris entre min et max ***/
int input_nb(int x, int y, int nb_carac, int min, int max);

		 /*** Saisie d'une chaine de caractres avec contrles de bord   ***/
char *input_chaine(int x, int y, int nb_carac);

/*********** Fonctions correspondants aux divers menus de saisie ***********/
int nouveau(void);    /*** Fonction du sous-menu FICHIER option 1 ***/
int charger(void);    /*** Fonction du sous-menu FICHIER option 2 ***/
int sauver(void);     /*** Fonction du sous-menu FICHIER option 3 ***/

int saisie_totale(void);/*** Fonction du sous-menu SAISIE option 1 ***/
int modif_point(void);  /*** Fonction du sous-menu SAISIE option 2 ***/
int modif_face(void);   /*** Fonction du sous-menu SAISIE option 3 ***/

int effacer_face(void); /*** Fonction du sous-menu EFFACER option 1 ***/
int effacer_point(void);/*** Fonction du sous-menu EFFACER option 2 ***/

/******** Fonctions propres aux traitements des points, affichage... ******
 *********** calculs, c'est  dire  la 3d proprement dite ****************/
void init_table(void);    /*** Initialise les tables sinus et cosinus ***/
void calcule(void);       /*** Calcule val. intermd. d'aprs angles  ***/
void tri(void);           /*** Tri faces selon leur loignement moyen ***/
void _3dto2d(int pt_depart, int pt_fin); /*** Passage points 3d -> 2d ***/
void dessine_axes(void);  /*** Dessine axes d'aprs leurs coordonnes ***/



/********************
   *** DECLARATIONS ***
	 ***     DES      ***
	   ***  VARIABLES   ***
		 *******************/

/***** Coordonnes des fentres (coins haut-gauche et bas-droit) ***********/
int x_hautgauche[5]={2,172,2,2,2};
int y_hautgauche[5]={2,2,272,315,333};
int x_basdroit[5]={166,637,637,637,637};
int y_basdroit[5]={266,266,311,331,349};


struct palettetype pal;/*** Structure contenant des infos sur la palette ***/
int sortie;     /**** 1-> sortie du programme, 0 sinon ***/
int quellepage; /**** dtermine la page graphique active (0 ou 1) ***/

int couleur_active = 1;   /**** couleur active de 1  14 inclus ****/
int composant_actif = 1;  /**** 1, 2 ou 3 pour respectivement R, V et B ****/

int _3d_axes_x[6]={-168,168,0,0,0,0}; /*** Coordonnes des axes ***/
int _3d_axes_y[6]={0,0,-168,168,0,0};
int _3d_axes_z[6]={0,0,0,0,-168,168};

int _2d_axes_x[6];   /*** Tableau recevant les coordonnes 2d des points ***/
int _2d_axes_y[6];   /*** des axes pour les dessiner  l'cran **/

char chaine_message[80];   /** Message sur touches  actionner **/
char chaine_erreur[80];    /** Message sur les erreurs survenues **/


/******** Donnes constitutives d'un objet : ce sont ici toutes les *********
 ******** variables que l'on va retrouver dans notre fichier .3DA ***********/
int nbpoints;   /**** Nombre de points total de l'objet 3d ***/
int nbfaces;    /**** Nombre de faces total de l'objet 3d ****/
int rouge[14] = {4,8,12,16,20,24,28,32,36,38,42,46,50,54}; /*** couleurs ***/
int  vert[14] = {28,24,20,16,12,8,4,0,58,54,50,46,42,38};
int  bleu[14] = {54,50,46,42,38,36,32,28,24,20,16,12,8,4};
int *x3d;      /* Coodonnes 3d ou */
int *y3d;      /* spatiales de l'objet */
int *z3d;
int faces[100][22];  /* Couleur des faces, Nombre de sommets par  */
					 /* faces, ndice des sommets                  */
int faces_triees[100][2]; /* Faces tries dans l'ordre */
						  /* de leur loignement moyen */
int *x2d;      /* tableaux des coordonnes 2d (planaires) */
int *y2d;      /* redimensionns par la fonction charge() */
int *new_z;    /* Nouvelles coordonnes spatiales z aprs transformation */


float tab_sin[360];           /* Table de prcalcul des sinus      */
float tab_cos[360];           /* Table de prcalcul des cosinus    */
int xangle,yangle,zangle;     /* Angles de rotation en x, y et z   */
float Ta,Tb,Tc,Td;            /* Variables temporaires             */
float Te,Tf,Tg,Th,Ti;         /* pour les calculs                  */

int tab_rempli = 0;       /*** Indique si tableaux vides ou remplis ***/
int flag = 2;          /*** Indique si filaire, ou pleine ***/


/********************
   *** DECLARATIONS ***
	 ***     DES      ***
	   ***  CONSTANTES  ***
		 *******************/

#define PT_FUITE 300.1   /* Point de fuite de la perspective    */
#define ANGLE 8          /* Nombre de degrs pour les rotations */





/**********************************************************
 **  Fonction principale de notre programme (boucle qui  **
 **    incrmente les angles et appelle les fonctions)   **
 **********************************************************/
void main(void)
{
	harderr(gestion_erreur);
	init_gfx();          /*** Initialisation de l'cran graphique ***/
	page_presentation(); /*** On appelle la page de prsentation ****/
	init_table();        /*** Table prcalcule de sinus et cosinus ***/
	calcule();           /*** Initialisation des variables Ta  Ti ***/
	_3dto2d(0,0);        /*** Initialisation des coordonnes 2d des axes ***/

	sortie = 0;
	quellepage = 0;
	xangle = yangle = zangle = 0;

	do{
		saisie();
		if (sortie == 0)
		{
			visu();
			couleur();
		}
	}while(sortie == 0);


  
	fin_gfx();
}





/**********************************************************
 **  Fonction affichant la page de prsentation avec les **
 **     noms des auteurs, et le numro de version du     **
 **       logiciel, ainsi que la date de cration        **
 **********************************************************/
void page_presentation()
{

	rectangle(10,10,620,340);
	rectangle(12,12,618,338);

	rectangle(105,45,520,63);
	outtextxy(120,50,"3DMOD V1.00 version finale termine le 18/05/1993");


	outtextxy(93,100,"3DMOD fait partie d'un projet intitul \"L'ANIMATION 3D\"");
	outtextxy(93,110,"ralis dans le cadre de leurs tudes de M.I.A. (Master");
	outtextxy(93,120,"en Informatique Approfondie)  l'ESIG LIMOGES, par deux");
	outtextxy(93,130,"tudiants de premire anne :");

	outtextxy(93,150,"  Jean Marc MICHEL (un Atariste convaincu)");
	outtextxy(93,160,"  Sbastien PISSAVY (un irrductible Amigaste)");


	outtextxy(80,220,"3DMOD V1.00 a t conu et programm par Sbastien PISSAVY");


	outtextxy(105,320,"<<< APPUYEZ SUR UNE TOUCHE POUR ACCEDER AU LOGICIEL >>>");




	do{
	}while (!kbhit());
}





/**********************************************************
 **   Fonction initialisant l'cran graphique en EGAHI   **
 **      c'est  dire une rsolution de 640*350*16       **
 **   Initialise galement les couleurs de la palette    **
 **********************************************************/
void init_gfx(void)
{
	int gdriver = EGA, gmode = EGAHI, errorcode;
	int i;

	initgraph(&gdriver, &gmode, "");
	errorcode = graphresult();
	if (errorcode != grOk)  /* une erreur a eu lieu*/
	{
		printf("Erreur graphique : %s\n",grapherrormsg(errorcode));
		printf("Frappez une touche pour quitter :");
		getch();
		exit(1); /* termine avec un code d'erreur */
	}
	getpalette(&pal);
	init_couleur();
}




/**********************************************************
 **   Fonction initialisant les tableaux tab_sin[] et    **
 **   tab_cos[] avec des valeurs de sinus et cosinus     **
 **     prcalcules, pour augmenter la rapidit         **
 **********************************************************/
void init_table(void)
{
     int i;                /* indice des tableaux  initialiser pour 360 */
     double r;             /* valeur en radian dont on cherche sin et cos */

     for ( i = 0 ; i < 360 ; i++ ) /* boucle pour les 360 possibles      */
     {
          r = i * 3.14159 / 180.0;  /* conversion des degrs en radians    */
          tab_sin[i] = sin(r);      /* remplissage de la table des sinus   */
          tab_cos[i] = cos(r);      /* remplissage de la table des cosinus */
     }
}



/**********************************************************
 **    Fonction qui traite les erreurs gravesdu DOS et   **
 **     qui renvoie toujours ABORT(2) pour viter les    **
 ** messages intempestifs du style RETRY, IGNORE, etc... **
 **********************************************************/
#pragma warn -par
 int gestion_erreur(int errval,int ax,int bp,int si)
 {
								/*** Si pas erreur disque ***/
	if (ax < 0)
	{
	   strcpy(chaine_erreur,"*** Erreur sur un priphrique ***");
	   hardretn(0);
	}
								/*** Sinon c'est une erreur disque ***/
	hardresume(0);
	return(0);
 }
#pragma warn +par






/**********************************************************
 **  Fonction initialisant la palette de couleurs grce  **
 **  aux valeurs RVB contenues dans les tableaux rouge[] **
 **                  vert[] et bleu[]                    **
 **********************************************************/
void init_couleur(void)
{
	int i;
					  /*** Pour chaque couleur, on donne ses composantes ***/
	for (i=1; i<15; i++)
	  setrgbpalette(pal.colors[i], rouge[i-1], vert[i-1], bleu[i-1]);
}






/**********************************************************
 **  Fonction fermant notre cran graphique et revenant  **
 **             au mode texte initial                    **
 **********************************************************/
void fin_gfx(void)
{
	closegraph();     /*** On ferme l'cran graphique **/
	gotoxy(1,1);      /*** On crit un message de fin **/
	printf("        Merci d'utiliser 3D MOD V1.00 (c) J.M.Michel & S.Pissavy mai 1993\n");
}








/**********************************************************
 **   Fonction dessinant une fentre suivant son numro  **
 **********************************************************/
void fenetre(int numero)
{
	rectangle(x_hautgauche[numero-1],y_hautgauche[numero-1],x_basdroit[numero-1],y_basdroit[numero-1]);
}





/**********************************************************
 ** Fonction dessinant un cadre autour de fentre active **
 **********************************************************/
void active(int numero)
{
	rectangle(x_hautgauche[numero-1]-1,y_hautgauche[numero-1]-1,x_basdroit[numero-1]+1,y_basdroit[numero-1]+1);
	rectangle(x_hautgauche[numero-1]-2,y_hautgauche[numero-1]-2,x_basdroit[numero-1]+2,y_basdroit[numero-1]+2);
}





/**********************************************************
 **    Fonction dessinant la ligne d'tat des messages   **
 **********************************************************/
void ligne1(void)
{
	setfillstyle(SOLID_FILL,15);               /*** Dessine ligne d'tat ***/
	bar(x_hautgauche[3],y_hautgauche[3],x_basdroit[3],y_basdroit[3]);

	setcolor(0);                                    /*** Affiche message ***/
	outtextxy(x_hautgauche[3]+3, y_hautgauche[3]+5, chaine_message);
	setcolor(15);
}



/**********************************************************
 **    Fonction dessinant la ligne d'tat des erreurs    **
 **********************************************************/
void ligne2(void)
{
	setfillstyle(SOLID_FILL,15);   /*** Dessine ligne d'tat des erreurs ***/
	bar(x_hautgauche[4],y_hautgauche[4],x_basdroit[4],y_basdroit[4]);

	setcolor(0);                     /*** Affiche les messages d'erreurs ***/
	outtextxy(x_hautgauche[4]+3, y_hautgauche[4]+5, chaine_erreur);
	setcolor(15);
}





/**********************************************************
 **     Fonction charge de dessiner l'intrieur de la   **
 **     fentre des couleurs et cela en fonction de la   **
 **     couleur active (pas d'effacement d'cran ici)    **
 **********************************************************/
void affiche_couleur(void)
{
	int i;
	char chaine_rouge[4], chaine_vert[4], chaine_bleu[4];

	for (i=1;i<15;i++)
	{
		/**** On dessine les rectangles de chaque couleur ***/
		setfillstyle(SOLID_FILL,i);
		bar(70+37*i,y_hautgauche[2]+6,100+37*i,y_hautgauche[2]+33);
	}


	/**** On affiche le cadre autour de la couleur active ***/
	setcolor(couleur_active);
	rectangle(68+37*couleur_active,y_hautgauche[2]+4,102+37*couleur_active,y_hautgauche[2]+35);
	rectangle(67+37*couleur_active,y_hautgauche[2]+3,103+37*couleur_active,y_hautgauche[2]+36);

	/**** on affiche un rectangle autour de la composante active ***/
	outtextxy(20,y_hautgauche[2]+8,"R   V   B");
	rectangle((composant_actif*32)-18,y_hautgauche[2]+4,(composant_actif*32),y_hautgauche[2]+19);

	/*** Conversion composantes en chaine, puis affichage ***/
	itoa(rouge[couleur_active-1],chaine_rouge,10);
	itoa(vert[couleur_active-1],chaine_vert,10);
	itoa(bleu[couleur_active-1],chaine_bleu,10);
	setcolor(15);
	setfillstyle(SOLID_FILL,15);
	outtextxy(16,298,chaine_rouge);
	outtextxy(48,298,chaine_vert);
	outtextxy(80,298,chaine_bleu);
}






/**********************************************************
 ** Fonction qui a pour seule tche de dessiner les axes **
 **      X, Y et Z d'aprs leurs coordonnes 2d, et      **
 **        d'afficher les lettres correspondantes        **
 **********************************************************/
void dessine_axes(void)
{
	/*** Limite la fentre graphique  la fentre de visualisation ***/
	setviewport(x_hautgauche[1],y_hautgauche[1],x_basdroit[1],y_basdroit[1],1);

	/*** Dessine les axes ***/
	setlinestyle(DOTTED_LINE,1,1);
	line(_2d_axes_x[0], _2d_axes_y[0], _2d_axes_x[1], _2d_axes_y[1]); /* X */
	line(_2d_axes_x[2], _2d_axes_y[2], _2d_axes_x[3], _2d_axes_y[3]); /* Y */
	line(_2d_axes_x[4], _2d_axes_y[4], _2d_axes_x[5], _2d_axes_y[5]); /* Z */
	outtextxy(_2d_axes_x[1], _2d_axes_y[1], "x'");
	outtextxy(_2d_axes_x[3], _2d_axes_y[3], "y'");
	outtextxy(_2d_axes_x[5], _2d_axes_y[5], "z'");
	outtextxy(_2d_axes_x[0], _2d_axes_y[0], "x");
	outtextxy(_2d_axes_x[2], _2d_axes_y[2], "y");
	outtextxy(_2d_axes_x[4], _2d_axes_y[4], "z");
	setlinestyle(SOLID_LINE,1,1);

	/*** Redimensionne la fentre graphique active ***/
	setviewport(0,0,639,349,1);

}




/**********************************************************
 **  Fonction rafraichissant la fentre de visualisation **
 **********************************************************/
void affiche_3d(void)
{
     int i,j,k,piv;
     int nbsommet;    /* nombre de sommets sur la face courante   */
	 int poly[40];    /* nombre de sommets maximum par faces = 20 */

	 dessine_axes();

	 /*** Limite les graphiques  cette portion de l'cran ***/
	 setviewport(x_hautgauche[1],y_hautgauche[1],x_basdroit[1],y_basdroit[1],1);

	 /*** Pour chaque face, on la dessine ***/
	 i = nbfaces - 1;
     do{
          piv = faces_triees[i][0];

		  nbsommet = faces[piv][1];

		  k = 1;
          for(j = 0 ; j < nbsommet * 2 ; j += 2)
          {
               k++;
               poly[j]  = x2d[faces[piv][k]];
               poly[j+1] = y2d[faces[piv][k]];
          }

          /* selection de la couleur de remplissage de la face */
		  setcolor(faces[piv][0]);

		  /* selection du motif de remplissage de la face */
		  setfillstyle(SOLID_FILL,faces[piv][0]);

		  /* Choix si filaire ou 3dpleine et action de remplir ou tracer */
		  switch(flag)
		  {
			case 0 : fillpoly(nbsommet,poly); break;       /*** 3dpleine ***/

			case 1 : setcolor(15);       /*** 3d filaire + faces caches ***/
					 setfillstyle(SOLID_FILL,0);
					 fillpoly(nbsommet,poly); break;

			case 2 : setcolor(15);             /*** 3d filaire classique ***/
					 for (k = 0 ; k < faces[i][1]-1 ; k++)
						line(x2d[faces[i][k+2]],y2d[faces[i][k+2]],x2d[faces[i][k+3]],y2d[faces[i][k+3]]);
					 line(x2d[faces[i][k+2]],y2d[faces[i][k+2]],x2d[faces[i][2]],y2d[faces[i][2]]);
					 break;
		  }
	 }while (--i > -1);
	 setcolor(15);
	 setfillstyle(SOLID_FILL,15);
	 setviewport(0,0,639,349,1);
}
	





/**********************************************************
 ** Fonction raffraichissant tout l'cran physique avec: **
 **                                                      **
 **  - win_active : 1  3 est la fentre active          **
 **                        1 -> Fentre de saisie        **
 **                        2 -> Fentre de visualisation **
 **                        3 -> Fentre des couleurs     **
 **  - menu_actif : 0  3 est le menu_actif              **
 **                        0 -> Menu principal           **
 **                        1 -> Menu fichier             **
 **                        2 -> Menu saisie              **
 **                        3 -> Menu effacer             **
 **********************************************************/
void refresh(int win_active, int menu_actif)
{
	setactivepage(quellepage);

	cleardevice();

	switch (menu_actif)
	{
		case 0  : affiche_menu();    break;
		case 1  : affiche_fichier(); break;
		case 2  : affiche_saisie();  break;
		case 3  : affiche_effacer(); break;
	}

	fenetre(1);
	fenetre(2);
	fenetre(3);
	active(win_active);
	ligne1();
	ligne2();

	affiche_couleur();

	if (tab_rempli == 1)
		affiche_3d();
	else
		dessine_axes();

	setvisualpage(quellepage);
	quellepage = (quellepage ^ 1);    /**** swap entre les pages 0 et 1 ***/
}






/**********************************************************
 **  Fonction qui analyse les caractres saisis au menu  **
 **   "SAISIE" afin d'aiguiller l'utilisateur vers les   **
 **        diffrentes fonctionnalits recherches       **
 **********************************************************/
void saisie(void)
{
	char carac;
	int entier;

	do{
		if (tab_rempli == 1)
			strcpy(chaine_message," [TAB] Chg Fentre [1] Menu fich. [2] Menu Saisie [3] Menu Effacer [4] Quitter");
		else
			strcpy(chaine_message," [TAB] Chg Fentre [1] Menu fich. [2] Menu Saisie [4] Quitter");
		refresh(1,0);
		carac = getch();
		if (carac == '1')
		{
			strcpy(chaine_erreur," ");
			if (tab_rempli == 1)
				strcpy(chaine_message,"[TAB] Chg Fentre [1] Eff. Donnes [2] Charger [3] Sauver <touche> Retour Menu");
			else
				strcpy(chaine_message,"  [TAB] Chg Fentre [2] Charger  <touche> Retour Menu");

			refresh(1,1);
			carac = getch();
			switch (carac)
			{
				case '1' : nouveau(); break;
				case '2' : charger(); break;
				case '3' : sauver();  break;
			}
		}
		else if (carac == '2')
			{
				strcpy(chaine_erreur," ");
				if (tab_rempli == 0)
					strcpy(chaine_message,"[TAB] Chg. Fentre. [1] Saisie  <touche> Retour Menu");
				else
					strcpy(chaine_message,"  [TAB] Chg. Fentre. [2] Modif.Pt [3] Modif.Face <touche> Retour Menu");
				refresh(1,2);
				carac = getch();
				switch (carac)
				{
					case '1' : saisie_totale(); break;
					case '2' : modif_point(); break;
					case '3' : modif_face(); break;
				}
			}
			else if ((carac == '3') && (tab_rempli == 1) && (nbpoints > 2))
				{
					strcpy(chaine_erreur," ");
					strcpy(chaine_message," [TAB] Chg. Fentre. [1] Eff.Face [2] Eff.Pt  <touche> Retour Menu");
					refresh(1,3);
					carac = getch();
					switch (carac)
					{
						case '1' : effacer_face(); break;
						case '2' : effacer_point(); break;
					}
				}
				else if (carac == '4')
					{
						strcpy(chaine_erreur," ");
						strcpy(chaine_message," [O] Quitter [N] Rester");
						refresh(1,0);

						rectangle(21,119,157,134);
						rectangle(22,120,156,133);
						outtextxy(30,123,"Quitter ? (O/N)");
						carac = getch();
						if ((carac == 'o') || (carac == 'O'))
						{
							sortie = 1;
							if (tab_rempli == 1)
							{
								outtextxy(10,153,"Il y a encore des");
								outtextxy(10,163,"donnes en mmoire.");
								outtextxy(10,173,"Voulez-vous les");
								outtextxy(10,183,"sauvegarder? (O/N)");
								strcpy(chaine_message," [O] Sauvegarder avant de quitter  [N] Quitter directement");
								ligne1();
								carac = getch();
								if ((carac == 'o') || (carac == 'O'))
								{
									entier = sauver();
									if (entier != 1)
										sortie = 0;
								}
							}
						}
					}
	}while((carac != 9) && (sortie == 0));
}





/**********************************************************
 **  Fonction qui gre la fentre de visualisation selon **
 **     choix de l'utilisateur (rotations de ANGLE)     **
 **********************************************************/
void visu(void)
{
	char carac;


	/*** Deux fois le test tab_rempli, pour avoir affichage plus net ***/
	if (tab_rempli == 1)
		strcpy(chaine_message," [TAB] Chg Fen. [2/3] Rt.X  [4/7] Rt.Y  [5/9] Rt.Z  [0] Init. [+] Chg Affich.");
	else
		strcpy(chaine_message," [TAB] Chg Fentre");

	do{
		refresh(2,0);
		carac = getch();
		if (tab_rempli == 1)
		{
			switch (carac)
			{
				/* rotations autour de l'axe x */
				case '2' : xangle += ANGLE; if (xangle == 360) xangle = 0; calcule(); _3dto2d(0,nbpoints); tri(); break;
				case '3' : xangle -= ANGLE; if (xangle == -ANGLE) xangle = 360-ANGLE; calcule(); _3dto2d(0,nbpoints); tri(); break;

				/* rotations autour de l'axe y */
				case '4' : yangle += ANGLE; if (yangle == 360) yangle = 0; calcule(); tri(); _3dto2d(0,nbpoints); break;
				case '7' : yangle -= ANGLE; if (yangle == -ANGLE) yangle = 360-ANGLE; calcule(); _3dto2d(0,nbpoints); tri(); break;

				/* rotations autour de l'axe z */
				case '5' : zangle += ANGLE; if (zangle == 360) zangle = 0; calcule(); tri(); _3dto2d(0,nbpoints); break;
				case '9' : zangle -= ANGLE; if (zangle == -ANGLE) zangle = 360-ANGLE; calcule(); _3dto2d(0,nbpoints); tri(); break;

				case '0' : zangle = yangle = xangle = 0; calcule(); _3dto2d(0,nbpoints); tri(); break;

				case '+' : flag++; if (flag>2) flag = 0; break;
			}
		}
	}while(carac != 9);
}




/**********************************************************
 **  Fonction qui analyse les caractres saisis dans la  **
 **  fentre des COULEURs afin d'aiguiller l'utilisateur **
 **         vers les fonctions programmes               **
 **********************************************************/
void couleur(void)
{
	char carac;

	strcpy(chaine_message," [TAB] Chg Fen. [<-/->] Slect.Couleur [R/V/B] Slect.Comp. [+/-] Aug./Dim.");

	do{
		refresh(3,0);
		carac = getch();
		switch (carac)
		{
			case 0   :  carac = getch();
						switch(carac)
						{
							case 'M' :	couleur_active++;
										if (couleur_active > 14)
											couleur_active = 1;
										break;

							case 'K' : 	couleur_active--;
										if (couleur_active<1)
											couleur_active = 14;
										break;
						}
						break;
			case 'r' :
			case 'R' :	composant_actif = 1; break;
			case 'v' :
			case 'V' :  composant_actif = 2; break;
			case 'b' :
			case 'B' :  composant_actif = 3; break;

			case '+' :  switch (composant_actif)
						{
							case 1 : if (rouge[couleur_active-1] < 63) rouge[couleur_active-1]++;break;
							case 2 : if (vert[couleur_active-1] < 63) vert[couleur_active-1]++;break;
							case 3 : if (bleu[couleur_active-1] < 63) bleu[couleur_active-1]++;break;

						}
						setrgbpalette(pal.colors[couleur_active],rouge[couleur_active-1],vert[couleur_active-1],bleu[couleur_active-1]);
						break;
			case '-' :  switch (composant_actif)
						{
							case 1 : if (rouge[couleur_active-1] > 0) rouge[couleur_active-1]--;break;
							case 2 : if (vert[couleur_active-1] > 0) vert[couleur_active-1]--;break;
							case 3 : if (bleu[couleur_active-1] > 0) bleu[couleur_active-1]--;break;
						}
						setrgbpalette(pal.colors[couleur_active],rouge[couleur_active-1],vert[couleur_active-1],bleu[couleur_active-1]);
						break;
		}
	}while(carac != 9);
}





/**********************************************************
 **      Fonction charge d'afficher le texte du menu    **
 **         principal dans la fentre de saisie          **
 **********************************************************/
void affiche_menu(void)
{
	int i, j, base = 0;

	outtextxy(12,20,"- MENU PRINCIPAL -");
	outtextxy(25,40,"  1. Fichier");
	outtextxy(25,49,"  2. Saisie");
	outtextxy(25,58,"  3. Effacer");
	outtextxy(25,76,"  4. Quitter");

	if ((tab_rempli == 0) || ((nbpoints < 3 ) && (nbfaces == 1)))
	{                                   /*** inaccessible en gris ***/
		for (j = 58 ; j < 70 ; j++)
		{
			base = base ^ 1;
			for (i = base+10 ; i < 163 ; i += 2)
			   putpixel(i,j,0);
		}
	}
}




/**********************************************************
 **  Fonction charge d'afficher le texte du sous-menu   **
 **          FICHIER dans la fentre de saisie           **
 **********************************************************/
void affiche_fichier(void)
{
	int i,j,base = 0;

	outtextxy(12,20," SOUS-MENU FICHIER");
	outtextxy(25,40,"  1. Nouveau");
	outtextxy(25,49,"  2. Charger");
	outtextxy(25,58,"  3. Sauver");
	if (tab_rempli == 0)
	{
		for (j = 40 ; j < 49 ; j++)  /*** Menus inaccessibles en 'gris' ***/
		{
			base = base ^ 1;
			for (i = base+10 ; i < 163 ; i += 2)
			   putpixel(i,j,0);
		}
		for (j = 58 ; j < 70 ; j++)
		{
			base = base ^ 1;
			for (i = base+10 ; i < 163 ; i += 2)
			   putpixel(i,j,0);
		}
	}
}


/**********************************************************
 **  Fonction charge d'afficher le texte du sous-menu   **
 **           SAISIE dans la fentre de saisie           **
 **********************************************************/
void affiche_saisie(void)
{
	int i,j, base = 0;

	outtextxy(12,20," SOUS-MENU SAISIE");
	outtextxy(8,40," 1. Saisie complte");
	outtextxy(8,49," 2. Modifier point");
	outtextxy(8,58," 3. Modifier face");

	if (tab_rempli == 1)             /*** Menus inaccessibles en 'gris' ***/
	{
		for (j = 40 ; j < 49 ; j++)
		{
			base = base ^ 1;
			for (i = base+10 ; i < 163 ; i += 2)
			   putpixel(i,j,0);
		}
	}
	else
	{
		for (j = 49 ; j < 70 ; j++)
		{
			base = base ^ 1;
			for (i = base+10 ; i < 163 ; i += 2)
			   putpixel(i,j,0);
		}
	}
}



/**********************************************************
 **  Fonction charge d'afficher le texte du sous-menu   **
 **           SAISIE dans la fentre de saisie           **
 **********************************************************/
void affiche_effacer(void)
{
	int base,i,j = 0;

	outtextxy(12,20," SOUS-MENU EFFACER");
	outtextxy(8,40," 1. Effacer face");
	outtextxy(8,50," 2. Effacer point");

	if (nbfaces < 2)
	{
		for (j = 40 ; j < 49 ; j++)  /*** Menus inaccessibles en 'gris' ***/
		{
			base = base ^ 1;                  /*** alterne 1 pixel sur 2 ***/
			for (i = base+10 ; i < 163 ; i += 2)
			   putpixel(i,j,0);
		}
	}
	if (nbpoints < 3)
	{
		for (j = 50 ; j < 59 ; j++)
		{
			base = base ^ 1;
			for (i = base+10 ; i < 163 ; i += 2)
			   putpixel(i,j,0);
		}
	}

}





/**********************************************************
 **     Fonction effectuant une saisie d'une chaine de   **
 **         caractres avec contrle des bords           **
 **********************************************************/
char *input_chaine(int x, int y, int nb_carac)
{
	int position,i;
	int drapeau = 0;
	int caractere;
	char *chaine;
	chaine = (char *)malloc(nb_carac * sizeof(char));
	chaine[nb_carac] = 0;


	position = 0;
	for (i=0;i<nb_carac;i++)            /*** on remplir la chaine de '' ***/
		chaine[i] = '';
	chaine[i]='\0';

	do
	{
		outtextxy(x,y,chaine);
		setfillstyle(SOLID_FILL,15);

		caractere = getch();
									 /*** test si caractre inscriptible ***/
		if ((caractere > 31) && (caractere < 123))
		{
			chaine[position] = caractere;
			if (position > nb_carac-2)             /*** Si fin de chaine ***/
			{
				drapeau = 0;
			}
			else
			{
				position = position + 1;
				drapeau = 1;
			}
		}
		else
		{
			if (caractere == 8)                    /*** Si caractre DEL ***/
			{
				if (position == 0)
				{
					chaine[position] = '';
				}
				else
					if ((position == nb_carac-1) && (drapeau == 0))
					{
						chaine[position] = '';
						drapeau = 1;
					}
					else
					{
						chaine[position-1] = '';
						position = position - 1;
						drapeau = 0;
					}
			}
		}
		setfillstyle(SOLID_FILL,0);
		bar(x,y,x+(nb_carac*8),y+8);           /*** jusqu' ENTER ou ESC ***/
	}while ((caractere != 13) && (caractere != 27));

	if (caractere == 13)                /*** SI ENTER ***/
	{
		for (i = 0 ; chaine[i] != ''; i++);  /*** on ajuste ici la taille */
		chaine[i] = '\0';                                     /* la chaine */
	}                                   /*** Sinon, cad si ESC ***/
	else
		strcpy(chaine,"");                             /** signe qu'ESC.. */

	return(chaine);
}



/**********************************************************
 ** Fonction effectuant une saisie formatte d'un nombre **
 **  ayant N caractres,  un endroit prcis de l'cran  **
 **    et avec contrle de forme et des effets de bord   **
 **********************************************************/
int input_nb(int x, int y, int nb_carac, int min, int max)
{
	char chaine_min[7],chaine_max[7];
	int position,i;
	int drapeau = 0;
	int carac;
	int nombre;
	char *chaine;
	chaine = (char *)malloc(nb_carac * sizeof(char));
	chaine[nb_carac] = 0;


	/********** Manipulation pour afficher la ligne de messages *******/
	itoa(min,chaine_min,10);
	itoa(max,chaine_max,10);
	strcpy(chaine_message," Saisissez un nombre compris entre ");
	strcat(chaine_message,chaine_min);
	strcat(chaine_message," et ");
	strcat(chaine_message,chaine_max);
	strcat(chaine_message," inclus   [ESC] Retour Menu");
	ligne1();

	do
	{
		nombre = 0;
		position = 0;
		for (i=0;i<nb_carac;i++)
			chaine[i] = '.';
		do
		{
			outtextxy(x,y,chaine);
			setfillstyle(SOLID_FILL,15);

			carac = getch();
							/*** teste si nombre ou +/- et 1re position ***/
			if (((carac > 46) && (carac < 59)) || ((carac == 43) || (carac == 45)) && (position == 0) && (min<0))
			{
				chaine[position] = carac;
				if (position > nb_carac-2)         /*** Si fin de chaine ***/
				{
					drapeau = 0;
				}
				else
				{
					position = position + 1;
					drapeau = 1;
				}
			}
			else
			{
				if (carac == 8)                              /*** Si DEL ***/
				{
					if (position == 0)
					{
						chaine[position] = '.';
					}
					else
						if ((position == nb_carac-1) && (drapeau == 0))
						{
							chaine[position] = '.';
							drapeau = 1;
						}
						else
						{
							chaine[position-1] = '.';
							position = position - 1;
							drapeau = 0;
						}
				}
			}
			setfillstyle(SOLID_FILL,0);
			bar(x,y,x+(nb_carac*8),y+8);

		}while ((carac != 13) && (carac != 27));
		if (carac == 27)
			return(9999);
		nombre = atoi(chaine);
	}while ((nombre < min) || (nombre > max));

	itoa(nombre,chaine,10);             /*** Conversion chaine -> nombre ***/
	outtextxy(x,y,chaine);

	return (nombre);
}





/**********************************************************
 **  Fonction calculant des valeurs intermdiaires pour  **
 **     chaque angle en fonction de sinus et cosinus     **
 **********************************************************/
void calcule(void)
{
	   /*** Calculs de valeurs intermdiaires qui serviront  _3dto2d(); ***/
	Ta = tab_cos[zangle] * tab_cos[yangle];
	Tb = tab_sin[zangle] * tab_cos[yangle];
	Tc = -tab_sin[yangle];
	Td = -tab_sin[zangle] * tab_cos[xangle] + tab_cos[zangle] * tab_sin[yangle] * tab_sin[xangle];
	Te = tab_cos[zangle] * tab_cos[xangle] + tab_sin[zangle] * tab_sin[yangle] * tab_sin[xangle];
	Tf = tab_cos[yangle] * tab_sin[xangle];
	Tg = tab_sin[zangle] * tab_sin[xangle] + tab_cos[zangle] * tab_sin[yangle] * tab_cos[xangle];
	Th = -tab_cos[zangle] * tab_sin[xangle] + tab_sin[zangle] * tab_sin[yangle] * tab_cos[xangle];
	Ti = tab_cos[yangle] * tab_cos[xangle];
}




/**********************************************************
 **  Fonction permettant de trier les faces suivant leur **
 **  loignement moyen et de les ranger dans un tableau  **
 **********************************************************/
void tri(void)
{
     int  g, i;
     int  som;      /* somme loignement multipli pour + de prcision */
     int  piv;      /* variable temporaire pour 'arer' le code        */
     int  triage;   /* dtermine si le tri est fini ou non             */
     int  swap;     /* contient variable temporaire pour le swap       */
     int  nbsommet; /* nombre de sommets de chaques faces              */

     /* Remplissage du tableau faces_triees */
     for(g = 0 ; g < nbfaces ; g++)
     {
          piv = faces_triees[g][0];
          nbsommet = faces[piv][1]; /* lit le nombre de sommet    */
          som = 0;                  /* initialisation de la somme */

          for(i = 0 ; i < nbsommet ; i++)
          {
               som = som + new_z[faces[piv][2+i]];  /* somme z de chaque sommet */
          }

          /* sauvegarde dans le tableau de la profondeur moyenne de la face */
          faces_triees[g][1] = (som * 10)/nbsommet;
     }

     /* Routine de tri  bulle proprement dite */
     do{
          triage = 0;
          for ( i = 0 ; i < nbfaces-1 ; i++)
		  {                                     /*** Si pas  leur place ***/
			   if (faces_triees[i][1]<faces_triees[i+1][1])
			   {                                /*** Tri pas encore fini ***/
					triage = 1;

                    /* on permute les deux valeurs du tableau */
                    swap = faces_triees[i][1];
                    faces_triees[i][1] = faces_triees[i+1][1];
                    faces_triees[i+1][1] = swap;

                    swap = faces_triees[i][0];
                    faces_triees[i][0] = faces_triees[i+1][0];
                    faces_triees[i+1][0] = swap;
               }
          }
     }while (triage == 1);
}








/**********************************************************
 **   Fonction qui transforme les points de coordonnes  **
 **    spatiales (3d, soit 3 coordonnes X, Y et Z) en   **
 **  coordonnes planaires (2d, soit 2 coordonnes X,Y), **
 **  en ceci  partir de l'indice d'un sommet de dpart  **
 **        jusqu' l'indice d'un sommet d'arrive        **
 **********************************************************/
void _3dto2d(int pt_depart, int pt_fin)
{
    int i;
    float Q;
    int x,y,z;

	/* transformation des points 3D en points 2D */
	for ( i = pt_depart ; i <= pt_fin ; i++)
	{
		  x=x3d[i]; /* coordonne x 3D du point */
		  y=y3d[i]; /* coordonne y 3D du point */
		  z=z3d[i]; /* coordonne z 3D du point */

         /* calcul de Q en fonction du point de fuite */
		 Q = 1 - ((Tc * x) + (Tf * y) + (Ti * z)) / PT_FUITE;

         /* calcul des coordonnes x 2D des points */
		 x2d[i] = 234 + ((Ta * x) + (Td * y) + (Tg * z)) / Q*1.1;

         /* calcul des coordonnes y 2D des points */
		 y2d[i] = 130 + (((Tb * x) + (Te * y) + (Th * z)) / Q*0.75);

         /* calcul des coordonnes z 3D aprs transformation pour le calcul */
         /* de la profondeur moyenne de la face par la fonction tri()       */
		 new_z[i] = (Ti * z) + (Tf * y) +(Tc * x);
	 }

	/*** Idem pour les points dlimitant les axes, de 3d -> 2d ***/
	for ( i = 0 ; i < 6 ; i++)
	{
		  x=_3d_axes_x[i]; /* coordonne x 3D du point */
		  y=_3d_axes_y[i]; /* coordonne y 3D du point */
		  z=_3d_axes_z[i]; /* coordonne z 3D du point */

		 /* calcul de Q en fonction du point de fuite */
		 Q = 1 - ((Tc * x) + (Tf * y) + (Ti * z)) / PT_FUITE;

		 /* calcul des coordonnes x 2D des axes */
		 _2d_axes_x[i] = 234 + ((Ta * x) + (Td * y) + (Tg * z)) / Q*1.1;

		 /* calcul des coordonnes y 2D des axes */
		 _2d_axes_y[i] = 130 + (((Tb * x) + (Te * y) + (Th * z)) / Q*0.75);
	 }
}






/**********************************************************
 **   Fonction qui efface toutes les donnes en mmoire  **
 **    aprs confirmation, efface tout sauf la palette   **
 **********************************************************/
int nouveau(void)
{
	char carac;

	if (tab_rempli == 1)
	{
		setfillstyle(SOLID_FILL,0);                  /*** Efface fentre ***/
		bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);
		outtextxy(10,10,"NOUVEAU");

		outtextxy(10,30,"Toutes les donnes");
		outtextxy(10,40,"en mmoire vont");
		outtextxy(10,50,"tre effaces.");
		outtextxy(10,60,"Seule la palette");
		outtextxy(10,70,"de couleurs sera");
		outtextxy(10,80,"conserve.");

		outtextxy(10,110,"Continuer ? (O/N)");

		strcpy(chaine_message," [O] Effacer les donnes [N] Retour au menu");
		ligne1();
		carac = getch();
		if ((carac != 'o') && (carac != 'O'))
			return(0);
		else
		{
			tab_rempli = 0;    /*** On n'efface pas vraiment, mais c'est ***/
			nbpoints = 0;                              /*** tout comme ! ***/
			nbfaces = 0;
		}
	}
	return(0);
}






/**********************************************************
 **     Fonction qui charge un objet .3DA en mmoire     **
 **   partir du disque (cf: fonction sauver() pour voir **
 **         la structure type d'un fichier .3da          **
 **********************************************************/
int charger(void)
{
	FILE *fichier;
	int i, j;
	char *nom;
	char carac;


	setfillstyle(SOLID_FILL,0);                      /*** Efface fentre ***/
	bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);
	outtextxy(10,10,"CHARGEMENT");

	if (tab_rempli == 1)
	{
		outtextxy(10,30,"Les donnes en");
		outtextxy(10,40,"mmoire vont tre");
		outtextxy(10,50,"effaces.");
		outtextxy(10,80,"Continuer ? (O/N)");

		strcpy(chaine_message," [O] Charger [N] Retour au menu");
		ligne1();
		carac = getch();
		if ((carac != 'o') && (carac != 'O'))
			return(0);
		setfillstyle(SOLID_FILL,0);
		bar(10,30,160,90);
	}

	outtextxy(10,50,"Nom du fichier :");
	strcpy(chaine_message," Saisissez le nom du fichier avec chemin d'accs    [ESC] Retour Menu");
	ligne1();
										   /*** Saisie du nom du fichier ***/
	nom = strupr(input_chaine(10,60,19));

	if (strcmp(nom,"") != 0)              /*** Si pas sortie avec [ESC] ***/
	{
		outtextxy(10,60,nom);

		/* ouverture du fichier objet en lecture/binaire */
		if ((fichier = fopen(nom, "rb")) == NULL)
		{
			strcpy(chaine_erreur,"     *** Erreur lors de lecture sur le fichier ");      /*** erreur ***/
			strcat(chaine_erreur,nom);
			strcat(chaine_erreur," ***");
			return(0);
		}
		/******** Lecture des couleurs sous forme RVB ******/
		for (i=0;i<14;i++)
		{
			fread(&rouge[i],sizeof(int),1,fichier);
			fread(&vert[i],sizeof(int),1,fichier);
			fread(&bleu[i],sizeof(int),1,fichier);
		}

		/* Lecture du nombre de faces de l'objet */
		fread(&nbfaces,sizeof(int),1,fichier);

		/* Lecture du nombre de points de l'objet */
		fread(&nbpoints,sizeof(int),1,fichier);

	   /*********************************************************************
		*** Ici on rajuste nos tableaux suivants les nbfaces et nbpoints ***
		*********************************************************************/

		/**** Test si mmoire suffisante ****/
		if ((malloc(7 * nbpoints * sizeof(int))) == NULL)
		{
			printf("Mmoire insuffisante pour l'allocation.\n");
			exit(1);  /* fin du programme si mmoire insuffisante */
		}

		/***** Ok, Donc on alloue la mmoire *****/
		x3d = (int *)malloc(nbpoints * sizeof(int));
		y3d = (int *)malloc(nbpoints * sizeof(int));
		z3d = (int *)malloc(nbpoints * sizeof(int));
		new_z = (int *)malloc(nbpoints * sizeof(int));
		x2d = (int *)malloc(nbpoints * sizeof(int));
		y2d = (int *)malloc(nbpoints * sizeof(int));


		/**** Tableaux rajusts, on peut maintenant lire le fichier ***/
		for (i = 0 ; i < nbpoints ; i++)
		{
			 fread(&x3d[i],sizeof(int),1,fichier);  /**** Lecture des ..     */
			 fread(&y3d[i],sizeof(int),1,fichier);  /* coordonnes X, Y.. et */
			 fread(&z3d[i],sizeof(int),1,fichier);  /* Z pour chaque point.  */
		}

		for (i = 0 ; i < nbfaces ; i++)
		{
			 fread(&faces[i][0],sizeof(int),1,fichier);    /*** couleur ***/
			 fread(&faces[i][1],sizeof(int),1,fichier);    /*** nb sommets ***/

			 for (j = 0 ; j < faces[i][1] ; j++)
			 {                          /*indices des sommets des faces ***/
				  fread(&faces[i][2+j],sizeof(int),1,fichier);
			 }
		}

		for (i = 0 ; i < nbfaces ; i++)  /* Remplissage car tri en a besoin */
			faces_triees[i][0] = i;

		/* fermeture du fichier de donnes */
		fclose(fichier);

		init_couleur();        /** Initialisation de la palette de couleurs **/
		calcule();
		_3dto2d(0,nbpoints);   /** Initisalisation des coordonnes 2d **/
		tri();
		tab_rempli = 1;  /** Drapeau indiquant que des donnes sont en mmoire **/
		return(1);
	}
	return(0);
}






/**********************************************************
 ** Fonction qui sauvegarde l'objet actuel sous la forme **
 **   d'un fichier objet ayant l'extension .3da. Il est  **
 ** compos de :  - Composants des 14 couleurs           **
 **               - Nombre de points                     **
 **               - Nombre de faces                      **
 **               - Coordonnes X,Y,Z des points         **
 **               - Nbsommets de la face                 **
 **               - Couleur de la face                   **
 **               - Indices des sommets de la face       **
 **********************************************************/
int sauver(void)
{
	FILE *fichier;
	int i, j;
	char *nom;
	char caractere;

	if (tab_rempli == 0)
	{
		return(0);
	}

	setfillstyle(SOLID_FILL,0);
	bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);
	outtextxy(10,10,"SAUVEGARDE");
	outtextxy(10,50,"Nom du fichier :");

	strcpy(chaine_message," Saisissez le nom du fichier avec le chemin d'accs    [ESC] Retour Menu");
	ligne1();

	nom = input_chaine(10,60,19);

	if (strcmp(nom,"") != 0)    /*** Si pas sortie avec [ESC] ***/
	{
		outtextxy(10,60,nom);

		if ((fichier = fopen(nom, "rb")) != NULL)  /** Si fichier existe ***/
		{
			outtextxy(10,100,"Le fichier spcifi");
			outtextxy(10,110,"existe dj.");
			outtextxy(10,120,"Voulez-vous");
			outtextxy(10,130,"l'craser? (O/N)");
			strcpy(chaine_message," [O] Ecraser l'ancien fichier et sauvegarder  [N] Retour Menu");
			ligne1();
			caractere = getch();
			if ((caractere != 'O') && (caractere != 'o'))
				return(0);
		}

		/* ouverture du fichier objet en criture/binaire */
		if ((fichier = fopen(nom, "wb")) == NULL)
		{
			strcpy(chaine_erreur,"     *** Erreur lors de l'criture du fichier ");
			strcat(chaine_erreur,nom);
			strcat(chaine_erreur," ***");
			return(0);
		}

		/******** Ecriture des couleurs sous forme RVB ******/
		for (i=0;i<14;i++)
		{
			fwrite(&rouge[i],sizeof(int),1,fichier);
			fwrite(&vert[i],sizeof(int),1,fichier);
			fwrite(&bleu[i],sizeof(int),1,fichier);
		}

		/* Ecriture du nombre de faces de l'objet */
		fwrite(&nbfaces,sizeof(int),1,fichier);

		/* Ecriture du nombre de points de l'objet */
		fwrite(&nbpoints,sizeof(int),1,fichier);

		for (i = 0 ; i < nbpoints ; i++)
		{
			 fwrite(&x3d[i],sizeof(int),1,fichier);  /*** Ecriture des ..     */
			 fwrite(&y3d[i],sizeof(int),1,fichier);  /* coordonnes X, Y.. et */
			 fwrite(&z3d[i],sizeof(int),1,fichier);  /* Z pour chaque point.  */
		}

		for (i = 0 ; i < nbfaces ; i++)
		{
			 fwrite(&faces[i][0],sizeof(int),1,fichier);    /*** couleur ***/
			 fwrite(&faces[i][1],sizeof(int),1,fichier);    /*** nb sommets ***/

			 for (j = 0 ; j < faces[i][1] ; j++)
			 {                          /*indices des sommets des faces ***/
				  fwrite(&faces[i][2+j],sizeof(int),1,fichier);
			 }
		}

		/* fermeture du fichier de donnes */
		fclose(fichier);
		return(1);
	}
	return(0);
}




/**********************************************************
 ** Fonction simple qui renvoie le plus petit entre deux **
 **    nombres entiers qui sont envoys  la fonction    **
 **********************************************************/
int mini(int num1, int num2)
{
	if (num1 < num2)
		return(num1);
	else
		return(num2);
}





/**********************************************************
 **     Fonction qui va se charger de rcuprer :        **
 **                - Nombre de points                    **
 **                - Nombre de faces                     **
 **                - Coordonnes X, Y et Z des points    **
 **                - Nombre de sommets des faces         **
 **                - Indices des sommets des faces       **
 **                - Couleur des faces                   **
 **********************************************************/
int saisie_totale(void)
{
	int i,g;             /**** compteurs de boucles ****/
	char chaine[10];


	if (tab_rempli == 0)
	{
		setfillstyle(SOLID_FILL,0);
		bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);


		outtextxy(10,10,"NOMBRE DE POINTS :");
		nbpoints = input_nb(15,20,3,2,500);     /*** 2 <= nbpoints <= 500 ***/
		if (nbpoints == 9999) return(0);

		outtextxy(10,50,"NOMBRE DE FACES  :");
		nbfaces = input_nb(15,60,3,1,100);     /*** 1 <= nbfaces <= 100 ***/
		if (nbfaces == 9999) return(0);


		/*** On alloue la mmoire ncessaire en fonction du nombre de points ***/
		x3d = (int *)malloc(nbpoints * sizeof(int));
		y3d = (int *)malloc(nbpoints * sizeof(int));
		z3d = (int *)malloc(nbpoints * sizeof(int));
		new_z = (int *)malloc(nbpoints * sizeof(int));
		x2d = (int *)malloc(nbpoints * sizeof(int));
		y2d = (int *)malloc(nbpoints * sizeof(int));


		outtextxy(10,90,"COORDONNEES 3D :");
		outtextxy(20,100,"     X    Y    Z");

		for (i = 0 ; i < nbpoints ; i++)
		{
			setfillstyle(SOLID_FILL,0);
			bar(4,115,163,125);
			itoa(i+1,chaine,10);
			strcat(chaine,".\0");
			outtextxy(8,115,chaine);
											  /*** Saisie coordonnes 3d ***/
			x3d[i] = input_nb(48,115,4,-150,150);
			if (x3d[i] == 9999) return(0);         /** si ESC ***/
			y3d[i] = input_nb(88,115,4,-150,150);
			if (y3d[i] == 9999) return(0);
			z3d[i] = input_nb(128,115,4,-150,150);
			if (z3d[i] == 9999) return(0);

			calcule();                             /*** Affichage points ***/
			_3dto2d(i,i);
			setviewport(x_hautgauche[1],y_hautgauche[1],x_basdroit[1],y_basdroit[1],1);
			putpixel(x2d[i],y2d[i],15);
			setviewport(0,0,639,349,1);

		}

		bar(4,80,163,200);
		outtextxy(10,90, "RENSEIGNEMENTS POUR");
		outtextxy(10,100,"CHAQUE FACE :");

		for (i = 0 ; i < nbfaces ; i++)
		{
			bar(4,115,163,200);

			outtextxy(8,115,"Face N");
			itoa(i+1,chaine,10);
			strcat(chaine," :\0");
			outtextxy(75,115,chaine);

			/** Saisie du nombre de sommets ***/
			outtextxy(8,125,"Nb Sommets:"); /* 2 <= indice <= min(20,nbpoints) */
			faces[i][1] = input_nb(100,125,2,2,mini(20,nbpoints));
			if (faces[i][1] == 9999) return(0);


			outtextxy(8,140,"INDICES SOMMETS :");
			for (g = 0 ; g < faces[i][1] ; g++)
			{
				bar(4,150,163,200);   /*** Saisie indices de sommets ***/
				outtextxy(8,150,"Indice sommet N");
				itoa(g+1,chaine,10);
				strcat(chaine," :\0");
				outtextxy(140,150,chaine);

				faces[i][g+2] = (input_nb(15,160,2,1,nbpoints))-1;
				if (faces[i][g+2] == 9999) return(0);
			}


			/***** Dessin de la face concerne en filaire ***/
			setviewport(x_hautgauche[1],y_hautgauche[1],x_basdroit[1],y_basdroit[1],1);
			for (g = 0 ; g < faces[i][1]-1 ; g++)
			{
				line(x2d[faces[i][g+2]],y2d[faces[i][g+2]],x2d[faces[i][g+3]],y2d[faces[i][g+3]]);
			}
			line(x2d[faces[i][g+2]],y2d[faces[i][g+2]],x2d[faces[i][2]],y2d[faces[i][2]]);
			setviewport(0,0,639,349,1);


			bar(4,140,163,200);
			outtextxy(8,135,"  Couleur :");  /*** saisie couleur des faces ***/
			faces[i][0] = input_nb(100,135,2,1,14);
			if (faces[i][0] == 9999) return(0);

		}

		/* Remplissage du tableau faces_triees car l'affichage en a besoin */
		for (i = 0 ; i < nbfaces ; i++)
			faces_triees[i][0] = i;

		tab_rempli = 1;      /*** Indicateur pour l'affichage ***/
		setfillstyle(SOLID_FILL,15);
	}
	return(0);
}




/**********************************************************
 **     Fonction appele par MODIFICATION de point et    **
 **  EFFACEMENT de point et qui affiche des informations **
 **            sur un point d'aprs son indice           **
 **********************************************************/
void affiche_etat_point(int numero)
{
	char chainedecarac[10];;

	outtextxy(10,70,"Coordonnes :");
	outtextxy(10,80,"     X    Y    Z");
	itoa(x3d[numero],chainedecarac,10);   /** affiche anciennes coord **/
	outtextxy(38,90,chainedecarac);
	itoa(y3d[numero],chainedecarac,10);
	outtextxy(78,90,chainedecarac);
	itoa(z3d[numero],chainedecarac,10);
	outtextxy(118,90,chainedecarac);
}




/**********************************************************
 **     Fonction appele par MODIFICATION de face et     **
 **  EFFACEMENT de face et qui affiche des informations  **
 **            sur un point d'aprs son indice           **
 **********************************************************/
void affiche_etat_face(int numero)
{
	char chainedecarac[10];
	int ligne, colonne, compteur;

	outtextxy(10,70,"Donnes actuelles :");
	outtextxy(8,80,"Nb sommets:");
	itoa(faces[numero][1],chainedecarac,10);
	outtextxy(100,80,chainedecarac);

	outtextxy(8,90,"  Couleur :");
	itoa(faces[numero][0],chainedecarac,10);
	outtextxy(100,90,chainedecarac);

	outtextxy(8,100,"  Indices :");
	ligne = 0;
	colonne = 0;
	for (compteur = 0 ; compteur < faces[numero][1] ; compteur++)
	{
		colonne++;
		if ((compteur % 5) == 0)
		{
			ligne++;
			colonne = 0;
		}
		itoa(faces[numero][compteur+2]+1,chainedecarac,10);
		outtextxy(20+(colonne*28),100+(ligne*12),chainedecarac);
	}
}




/**********************************************************
 **  Fonction de modification des coordonnes de points  **
 **********************************************************/
int modif_point(void)
{
	int indice;
	int buf_x, buf_y, buf_z;

	if (tab_rempli == 1)
	{
		setfillstyle(SOLID_FILL,0);     /*** Efface la fentre de saisie ***/
		bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);

		outtextxy(10,10,"MODIFICATION POINT");
		outtextxy(10,25,"Indice du point :");

		indice = input_nb(10,35,3,1,nbpoints);
		if (indice == 9999) return(0);                 /*** teste si ESC ***/
		indice--;

		affiche_etat_point(indice);

		outtextxy(10,120,"Nouvelles coord. :");
		outtextxy(10,130,"     X    Y    Z");

		buf_x = input_nb(38,140,4,-150,150);
		if (buf_x == 9999) return(0);                  /*** teste si ESC ***/

		buf_y = input_nb(78,140,4,-150,150);
		if (buf_y == 9999) return(0);                  /*** teste si ESC ***/

		buf_z = input_nb(118,140,4,-150,150);
		if (buf_z == 9999) return(0);                  /*** teste si ESC ***/

					/*** On charge les nouvelles valeurs dans le tableau ***/
		x3d[indice] = buf_x;
		y3d[indice] = buf_y;
		z3d[indice] = buf_z;
		_3dto2d(indice,indice);  /*** Changement dans l'affichage points ***/
		tri();
	}
	return(0);
}





/**********************************************************
 **   Fonction charge de modifier les caractristiques  **
 **   d'une face (nbsommet, indices points, et couleur)  **
 **********************************************************/
int modif_face(void)
{
	int indice, compteur;
	int buffer[22];
	char chainedecarac[10];

	if (tab_rempli == 1)
	{
		setfillstyle(SOLID_FILL,0);     /*** Efface la fentre de saisie ***/
		bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);

		outtextxy(10,10,"MODIFICATION FACE");
		outtextxy(10,25,"Indice de la face :");

		indice = input_nb(10,35,3,1,nbfaces);
		if (indice == 9999) return(0);
		indice--;

		affiche_etat_face(indice);

		/**** On entre de nouvelles donnes  partir de l  ***/
		outtextxy(10,175,"Nouvelles donnes :");

		/** Saisie du nombre de sommets ***/
		outtextxy(8,185,"Nb Sommets:"); /* 2 <= nbsommet <= mini(20,nbpoints) */
		buffer[1] = input_nb(100,185,2,2,mini(20,nbpoints));
		if (buffer[1] == 9999) return(0);              /*** teste si ESC ***/

		for (compteur = 0 ; compteur < buffer[1] ; compteur++)
		{
			bar(4,195,163,230);           /*** Saisie indices de sommets ***/
			outtextxy(8,195,"Indice sommet N");
			itoa(compteur+1,chainedecarac,10);
			strcat(chainedecarac," :\0");
			outtextxy(140,195,chainedecarac);
			buffer[compteur+2] = (input_nb(15,205,2,1,nbpoints))-1;
			if (buffer[compteur+2] == 9998) return(0); /*** teste si ESC ***/
		}

		bar(4,195,163,230);
		outtextxy(8,195,"  Couleur :");    /*** saisie couleur des faces ***/
		buffer[0] = input_nb(100,195,2,1,14);
		if (buffer[0] == 9999) return(0);              /*** teste si ESC ***/


		for (compteur = 0 ; compteur < 22 ; compteur++) /*** remplit tableau ***/
			faces[indice][compteur] = buffer[compteur];
		tri();
	}
	return(0);
}




/**********************************************************
 **        Fonction d'effacement d'une face              **
 **********************************************************/
int effacer_face(void)
{
	int indice, i , j;
	char caractere;

	if (nbfaces > 1)
	{
		setfillstyle(SOLID_FILL,0);     /*** Efface la fentre de saisie ***/
		bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);

		outtextxy(10,10,"EFFACEMENT FACE");
		outtextxy(10,25,"Indice de la face :");

		indice = input_nb(10,35,3,1,nbfaces);
		if (indice == 9999) return(0);
		indice--;

		affiche_etat_face(indice);

		outtextxy(10,150,"Confirmation (O/N)");
		strcpy(chaine_message," [O] Effacer face [N] Annuler");
		ligne1();
		caractere = getch();
		if ((caractere == 'o') || (caractere == 'O'))
		{
			for (i = indice ; i < nbfaces ; i++) /*** On dcale toutes les */
			{                                    /*** faces, pour combler  */
				for (j = 0 ; j < 22 ; j++)       /* le trou de l'effacement */
				{
					faces[i][j] = faces[i+1][j];
				}
			}

			nbfaces = nbfaces - 1;           /*** Il y a une face de moins */
			for (i = 0 ; i < nbfaces ; i++)
				faces_triees[i][0] = i;
			tri();
		}
	}
	return(0);
}



/**********************************************************
 **        Fonction d'effacement d'un point              **
 **********************************************************/
int effacer_point(void)
{
	int indice, i, j, g;
	char caractere;

	if (nbpoints > 2)
	{
		setfillstyle(SOLID_FILL,0);     /*** Efface la fentre de saisie ***/
		bar(x_hautgauche[0]+1,y_hautgauche[0]+1,x_basdroit[0]-1,y_basdroit[0]-1);

		outtextxy(10,10,"EFFACEMENT POINT");
		outtextxy(10,25,"Indice du point :");

		indice = input_nb(10,35,3,1,nbpoints);
		if (indice == 9999) return(0);                 /*** teste si ESC ***/
		indice--;

		affiche_etat_point(indice);

		outtextxy(10,120,"Confirmation (O/N)");
		strcpy(chaine_message," [O] Effacer point [N] Annuler");
		ligne1();
		caractere = getch();
		if ((caractere == 'o') || (caractere == 'O'))
		{
			/*** Effacement du point d'indice INDICE ***/
			for (i = indice ; i < nbpoints ; i++)
			{
				x3d[i] = x3d[i+1];
				y3d[i] = y3d[i+1];
				z3d[i] = z3d[i+1];
				x2d[i] = x2d[i+1];
				y2d[i] = y2d[i+1];
				new_z[i] = new_z[i+1];
			}
			nbpoints--;

			for (i = 0 ; i < nbfaces ; i++)
			{
				for (j = 2 ; j < faces[i][1]+2 ; j++)
				{
					if (faces[i][j] == indice)   /*** si ya indice du point */
					{                            /** supprime et nbsommet-- */
						for (g = j ; g < faces[i][1]+2 ; g++)
						{
							faces[i][g] = faces[i][g+1];
						}
						faces[i][1]--;
					}
				}
				for (j = 2 ; j < faces[i][1]+2 ; j++)
				{
					if (faces[i][j] > indice)   /*** On corrige les indices */
					{                           /** car on a soustrait les **/
						faces[i][j]--;          /** points de 1 ci-dessus ***/
					}
				}
			}
		}
	}
	return(0);
}
